<template>
  <div :class="[
    'bg-[#11021B] rounded-lg text-white transition-all duration-300 flex flex-col relative instrument-panel',
    expanded ? 'w-72 p-4' : 'w-16 h-60', position === 'left' ? 'relative left-20 top-62' : 'relative left-20 top-52',
    'z-50']">

    <!-- Collapsed View -->
    <div v-if="!expanded" >
      <button
        class="absolute -right-1 top-0 left-0 mx-auto w-6 h-8 bg-[#11021B] rounded-r-lg flex items-center justify-center hover:bg-[#1B0B2B] transition-colors z-[60] cursor-pointer"
        @click="expanded = true, updateList()">
        <span class="text-lg select-none transform">></span>
      </button>
      <div class="w-full h-full flex flex-col items-center pt-10">
        <!-- Potential Collisions Section -->
        <div class="w-full flex flex-col items-center border-t border-b border-red-500 py-4">
          <div class="text-4xl font-bold text-red-500">
            {{ dataList.length }}
          </div>
          <div class="text-2xl text-red-500">★</div>
        </div>

        <!-- Time Section -->
        <div class="text-2xl mt-4">{{ lastUpdateMinutes }}</div>

        
        <!-- Navigation Buttons -->
          <!-- COMMENTED OUT
          <div class="mt-auto flex flex-col space-y-6 mb-6">
            <button class="w-8 h-8 flex items-center justify-center hover:bg-[#1B0B2B] transition-colors text-xl">▼</button>
            <button class="w-8 h-8 flex items-center justify-center hover:bg-[#1B0B2B] transition-colors text-xl">≡</button>
            <button class="w-8 h-8 flex items-center justify-center hover:bg-[#1B0B2B] transition-colors text-xl">◈</button>
          </div>
        -->
      </div>
    </div>


  <!-- Expanded Views -->
  <div v-else class="h-full">
    
    <button
      class="absolute right-0 top-0 w-12 h-12 bg-[#11021B] rounded-r-lg flex items-center justify-center hover:bg-[#1B0B2B] transition-colors z-[60] cursor-pointer"
      @click="expanded = false">
      <span class="text-lg select-none transform -rotate-9">×</span>
    </button>
    
    <!-- Header -->
    <div v-if="showCDMListAllowed" class="flex justify-between items-center mb-4">
      <h2 class="text-base font-normal">{{ showCDMList ? 'Potential Collisions' : 'Potential Collision Instruments' }}</h2>
    </div>

    <div v-if="showDRMListAllowed" class="flex justify-between items-center mb-4">
      <h2 class="text-base font-normal">{{ showDRMList ? 'Disaster Reports' : 'Disaster Report Instruments' }}</h2>
    </div>

    <!-- Potential Collisions View -->
    <div v-if="showCDMList && showCDMListAllowed" class="space-y-4">
      
      <div v-for="eventData in dataList" :key="eventData.id" 
        class="p-3 rounded bg-[#1A1A1A] hover:bg-[#2A1A1A] cursor-pointer transition-colors">
        <div class="flex justify-between items-center">
          <span class="text-sm">ID: {{ eventData.id.substring(0,15) }}</span>
        </div>
        <div class="flex justify-between items-center">
          <span class="text-sm text-red-500">{{ (eventData.arguments.pc / 1000).toFixed(1) }}%</span>
        </div>
        <div class="text-xs text-gray-400 mt-1">
          {{ eventData.lat.toFixed(1) }}°, {{ eventData.lng.toFixed(1) }}°
        </div>
        <div class="text-xs text-gray-400">
          Approach time in {{ formatTimeDifference(eventData.arguments.tca - Math.floor(Date.now() / 1000)) }}
        </div>
      </div>
      <button 
        @click="toggleCDMList" 
        class="w-full text-left text-sm hover:text-gray-300 mb-4 flex justify-between items-center"
      >
        <span>Back to Instruments</span>
        <span class="text-lg"><</span>
      </button>
    </div>

    <!-- Disaster Alert View -->
    <div v-if="showDRMList && showDRMListAllowed" class="space-y-4">
      <div v-for="eventData in dataList" :key="eventData.id" 
        class="p-3 rounded bg-[#1A1A1A] hover:bg-[#2A1A1A] cursor-pointer transition-colors">
        <div class="flex justify-between items-center">
          <span class="text-sm">ID: {{ eventData.id.substring(0,15) }}</span>
        </div>
        <div class="flex justify-between items-center">
          <span class="text-sm text-red-500">Category {{ (eventData.arguments.category ) }}</span>
        </div>
        <div class="text-xs text-gray-400 mt-1">
          {{ eventData.lat.toFixed(1) }}°, {{ eventData.lng.toFixed(1) }}°
        </div>
        <div class="text-xs text-gray-400">
          Event time is {{ eventData.arguments.predictedTime > Math.floor(Date.now() / 1000) ? 
          "in "+formatTimeDifference(eventData.arguments.predictedTime - Math.floor(Date.now() / 1000)) :
            formatTimeDifference(eventData.arguments.predictedTime - Math.floor(Date.now() / 1000))+" ago" }}
        </div>
      </div>
      <button 
        @click="toggleDRMList" 
        class="w-full text-left text-sm hover:text-gray-300 mb-4 flex justify-between items-center"
      >
        <span>Back to Instruments</span>
        <span class="text-lg"><</span>
      </button>
    </div>


    <!-- Main Instrument View -->
    <div v-else>
      <!-- Potential Collisions -->
      <div v-if="!showCDMList && showCDMListAllowed"> 
        <div class="flex items-center justify-between mb-6 cursor-pointer" @click="toggleCDMList">
          <div class="flex items-center">
            <span class="text-3xl font-bold text-white mr-2">{{ dataList.length }}</span>
            <div class="text-sm">
              <div class="text-[#E83B69]">potential</div>
              <div class="text-[#E83B69]">collisions</div>
            </div>
          </div>
          <span class="text-xl">»</span>
        </div>

        <!-- Last Update -->
        <div class="flex items-center mb-6">
          <span class="text-3xl font-bold mr-2">{{ lastUpdateMinutes }}</span>
          <div class="text-sm text-gray-400">
            <div>minutes since</div>
            <div>last update</div>
          </div>
        </div>

        <!-- Filters -->
        <div class="mb-6">
          <div class="flex items-center mb-2">
            <svg class="w-4 h-4 mr-2" viewBox="0 0 24 24" fill="none" xmlns="http://www.w3.org/2000/svg">
              <path d="M4 4h16v2.4l-6.4 6.4v8.8l-3.2-1.6v-7.2L4 6.4V4z" stroke="currentColor" stroke-width="2"/>
            </svg>
            <span class="text-sm">Filters</span>
          </div>
          
          <!-- Collision probability filter -->
          <div class="mb-4">
            <div class="text-xs text-gray-400 mb-1">Collision probability filter</div>
            <div class="text-sm">40% - 100%</div>
          </div>

          <!-- Passing distance filter -->
          <div>
            <div class="text-xs text-gray-400 mb-1">Passing distance filter</div>
            <div class="text-sm">10m - 100m</div>
          </div>
        </div>
      

        <!-- Legend -->
        <div class="mb-6">
          <div class="text-sm mb-2">Collision Probability Legend</div>
          <div class="space-y-2 text-xs">
            <div class="flex items-center">
              <div class="w-3 h-3 rounded-full bg-red-500 mr-2"></div>
              <div>
                <div>high risk (75-100%)</div>
                <div class="text-gray-400">high chance of collision</div>
              </div>
            </div>
            <div class="flex items-center">
              <div class="w-3 h-3 rounded-full bg-orange-500 mr-2"></div>
              <div>
                <div>medium risk (25-75%)</div>
                <div class="text-gray-400">moderate chance of collision</div>
              </div>
            </div>
            <div class="flex items-center">
              <div class="w-3 h-3 rounded-full bg-green-500 mr-2"></div>
              <div>
                <div>low risk (0-25%)</div>
                <div class="text-gray-400">low chance of collision</div>
              </div>
            </div>
          </div>
        </div>
      </div>

      <div v-if="!showDRMList && showDRMListAllowed"> 
        <div class="flex items-center justify-between mb-6 cursor-pointer" @click="toggleDRMList">
          <div class="flex items-center">
            <span class="text-3xl font-bold text-white mr-2">{{ dataList.length }}</span>
            <div class="text-sm">
              <div class="text-[#E83B69]">disaster</div>
              <div class="text-[#E83B69]">alerts</div>
            </div>
          </div>
          <span class="text-xl">»</span>
        </div>

        <!-- Last Update -->
        <div class="flex items-center mb-6">
          <span class="text-3xl font-bold mr-2">{{ lastUpdateMinutes }}</span>
          <div class="text-sm text-gray-400">
            <div>minutes since</div>
            <div>last update</div>
          </div>
        </div>

        <!-- Legend -->
        <div class="mb-6">
          <div class="text-sm mb-2">Tropical Storm Legend</div>
          <div class="space-y-2 text-xs">
            <div class="flex items-center">
              <div class="w-3 h-3 rounded-full mr-2" style="background-color:#ff0000;"></div>
              <div>
                <div>Category 5</div>
                <div class="text-gray-400">Tropical Storm</div>
              </div>
            </div>
            <div class="flex items-center">
              <div class="w-3 h-3 rounded-full mr-2" style="background-color:#ea5c00;"></div>
              <div>
                <div>Category 4</div>
                <div class="text-gray-400">Tropical Storm</div>
              </div>
            </div>
            <div class="flex items-center">
              <div class="w-3 h-3 rounded-full mr-2" style="background-color:#ca8600;"></div>
              <div>
                <div>Category 3</div>
                <div class="text-gray-400">Tropical Storm</div>
              </div>
            </div>
            <div class="flex items-center">
              <div class="w-3 h-3 rounded-full mr-2" style="background-color:#a6a200;"></div>
              <div>
                <div>Category 2</div>
                <div class="text-gray-400">Tropical Storm</div>
              </div>
            </div>
            <div class="flex items-center">
              <div class="w-3 h-3 rounded-full mr-2" style="background-color:#7ab900;"></div>
              <div>
                <div>Category 1</div>
                <div class="text-gray-400">Tropical Storm</div>
              </div>
            </div>
            <div class="flex items-center">
              <div class="w-3 h-3 rounded-full mr-2" style="background-color:#29cd00;"></div>
              <div>
                <div>Category 0</div>
                <div class="text-gray-400">Tropical Storm</div>
              </div>
            </div>
          </div>
        </div>
      </div>

      <!-- Additional Sections -->
      <!-- COMMENTED OUT <div class="space-y-2">
        <div class="flex items-center p-2 hover:bg-[#1A1A1A] rounded cursor-pointer">
          <svg class="w-5 h-5 mr-2" viewBox="0 0 24 24" fill="none" xmlns="http://www.w3.org/2000/svg">
            <path d="M19 3H5c-1.1 0-2 .9-2 2v14c0 1.1.9 2 2 2h14c1.1 0 2-.9 2-2V5c0-1.1-.9-2-2-2zm-5 14H7v-2h7v2zm3-4H7v-2h10v2zm0-4H7V7h10v2z" fill="currentColor"/>
          </svg>
          <span>CDM Requests</span>
        </div>
        <div class="flex items-center p-2 hover:bg-[#1A1A1A] rounded cursor-pointer">
          <svg class="w-5 h-5 mr-2" viewBox="0 0 24 24" fill="none" xmlns="http://www.w3.org/2000/svg">
            <path d="M19 3H5c-1.1 0-2 .9-2 2v14c0 1.1.9 2 2 2h14c1.1 0 2-.9 2-2V5c0-1.1-.9-2-2-2zm-2 10h-4v4h-2v-4H7v-2h4V7h2v4h4v2z" fill="currentColor"/>
          </svg>
          <span>Analytics</span>
        </div>
      </div>
      
      <button 
        @click="toggleCDMList" 
        class="w-full text-left text-sm hover:text-gray-300 flex justify-between items-center"
      >
        <span>View Potential Collisions</span>
        <span class="text-lg">></span>
      </button>
      -->
    </div>
  </div>
</div>
</template>

<script setup lang="ts">
import { ref, onMounted, defineProps, onBeforeMount, onUnmounted, inject, watch } from 'vue'
import { useEventBus } from '@/components/UI/eventBus'
import { fetchCDMData, fetchDRMData } from '@/services/FetchData' // Import the service
import { formatDistance } from 'date-fns';

const globeMode = inject('globeMode') as { value: string }

const eventBus = useEventBus()

// Props
const props = defineProps({
  position: {
    type: String,
    required: true,
    validator(value: string) {
      return ['left', 'right'].includes(value)
    }
  }
})

// State
const selectedCDM = ref<any>(null)
const dataList = ref<any[]>([])

const loadCDMData = async () => {
  dataList.value = await fetchCDMData()
}

const loadDRMData = async () => {
  dataList.value = await fetchDRMData()
}

const formatTimeDifference = (timeDifferenceInSeconds) => {
    const now = new Date();
    const targetTime = new Date(now.getTime() + timeDifferenceInSeconds * 1000);
    return formatDistance(now, targetTime, { includeSeconds: true });
};

// Watch for CDM hover events (single instance)
const updateSelectedCDM = (cdm: any) => {
  selectedCDM.value = cdm
}

onBeforeMount(() => {
  eventBus.on('cdm-hovered', updateSelectedCDM)
})

onUnmounted(() => {
  eventBus.off('cdm-hovered', updateSelectedCDM)
})



// Panel state
const expanded = ref(false)
const showCDMList = ref(false)
const showCDMListAllowed = ref(false)
const showDRMList = ref(false)
const showDRMListAllowed = ref(false)


// Methods
const toggleCDMList = () => {
  showCDMList.value = !showCDMList.value
  // Keep panel expanded when closing potential collisions view
  if (!showCDMList.value) {
    expanded.value = true
  } else {
    // Ensure panel is expanded when showing potential collisions
    expanded.value = true
  }
}

// Methods
const toggleDRMList = () => {
  showDRMList.value = !showDRMList.value
  // Keep panel expanded when closing potential collisions view
  if (!showDRMList.value) {
    expanded.value = true
  } else {
    // Ensure panel is expanded when showing potential collisions
    expanded.value = true
  }
}



// Computed properties
const lastUpdate = ref(new Date())
const lastUpdateMinutes = ref('0')

// Update the last update time every minute
const updateLastUpdate = () => {
  const now = new Date()
  const diff = Math.floor((now.getTime() - lastUpdate.value.getTime()) / 60000)
  lastUpdateMinutes.value = `${diff}`
}


// Periodic data update function
const updateList = () => {
  if (globeMode.value === "DRM") {
    loadDRMData()
  } else {
    loadCDMData()
  }
  showCDMList.value = false
  showCDMListAllowed.value = globeMode.value == "CDM"
  showDRMList.value = false
  showDRMListAllowed.value = globeMode.value == "DRM"
}


watch(globeMode, async (newMode) => {
  updateList()
})

onMounted(async () => {
  updateList()
  setInterval(updateList, 30000)
  setInterval(updateLastUpdate, 60000)
})

</script>

<style scoped>
.instrument-panel {
  position: fixed;
  top: 5rem;
  left: 0rem;
  box-shadow: 0 4px 6px -1px rgba(0, 0, 0, 0.1), 0 2px 4px -1px rgba(0, 0, 0, 0.06);
  z-index: 50;
  overflow-y: auto;
  scrollbar-width: thin;
  scrollbar-color: rgba(255, 255, 255, 0.2) transparent;
  backdrop-filter: blur(8px);
  transition: width 0.3s ease-in-out;
}

/* Scrollbar Styling */
.instrument-panel::-webkit-scrollbar {
  width: 6px;
}

.instrument-panel::-webkit-scrollbar-track {
  background: transparent;
}

.instrument-panel::-webkit-scrollbar-thumb {
  background-color: rgba(255, 255, 255, 0.2);
  border-radius: 3px;
}

/* Interactive Elements */
button {
  transition: all 0.2s ease-in-out;
  cursor: pointer;
  user-select: none;
}

button:hover {
  opacity: 0.8;
  transform: scale(1.05);
}

button:active {
  transform: scale(0.95);
}

/* Panel Transitions */
.panel-enter-active,
.panel-leave-active {
  transition: transform 0.3s ease-in-out, opacity 0.3s ease-in-out;
}

.panel-enter-from,
.panel-leave-to {
  transform: translateX(20px);
  opacity: 0;
}

/* CDM Items */
.cdm-item {
  transition: all 0.2s ease;
  cursor: pointer;
}

.cdm-item:hover {
  background-color: rgba(255, 255, 255, 0.05);
  transform: translateX(4px);
}

/* Progress Bars */
.progress-bar {
  transition: width 0.3s ease-in-out, background-color 0.3s ease;
  position: relative;
  overflow: hidden;
}

.progress-bar::after {
  content: '';
  position: absolute;
  top: 0;
  left: 0;
  right: 0;
  bottom: 0;
  background: linear-gradient(
    90deg,
    rgba(255, 255, 255, 0) 0%,
    rgba(255, 255, 255, 0.1) 50%,
    rgba(255, 255, 255, 0) 100%
  );
  transform: translateX(-100%);
  animation: shimmer 2s infinite;
}

@keyframes shimmer {
  100% {
    transform: translateX(100%);
  }
}

/* Filter Sections */
.filter-section {
  transition: all 0.2s ease;
  border: 1px solid transparent;
}

.filter-section:hover {
  background-color: rgba(255, 255, 255, 0.05);
  border-color: rgba(255, 255, 255, 0.1);
}

/* Star Animation */
@keyframes pulse {
  0% { transform: scale(1); opacity: 1; }
  50% { transform: scale(1.1); opacity: 0.8; }
  100% { transform: scale(1); opacity: 1; }
}

.star-icon {
  animation: pulse 2s infinite ease-in-out;
}

/* Time Update */
.time-update {
  transition: color 0.3s ease;
}

.time-update:hover {
  color: rgba(255, 255, 255, 0.9);
}

.panel-enter-active {
  transition: opacity 0.3s ease;
}
</style>